	org	$8000000
	
	b	main
	
	org	$80000e4

	dc.l	VBlank

	include	core/irq.s
	
main:
	mov	r0, #$80
	mov	r1, #$e4
	mov	r0, r0, asl #20
	orr	r0, r1, r0 ; load an exception handler address
	mov	r1, #$30
	mov	r2, #$7f
	mov	r1, r1, asl #20
	mov	r2, r2, asl #8
	orr	r1, r2, r1
	mov	r2, #$fc
	orr	r1, r2, r1 ; get $3007ffc address
	ldr	r2, [r0]
	str	r2, [r1] ; load a return code
	mov	r6, #$16
	mov	r6, r6, asl #4 ; bitmap width is 352
	mov	r1, #$40
	mov	r1, r1, asl #20
	ldrh	r0, [r1]
	orr	r0, r0, #3
	strh	r0, [r1] ; switch to bitmap mode #0
	mov	r0, #$82
	mov	r1, #$a8
	mov	r0, r0, asl #20
	mov	r1, r1, asl #12
	orr	r0, r1, r0 ; bitmap image address
	mov	r1, #$60
	mov	r1, r1, asl #20 ; VRAM start address
	mov	r2, #$a0 ; visible field height
NewRow:
	mov	r3, #$f0 ; visible field width
	mov	r4, r0
LoadPixel:
	ldrh	r5, [r4]
	add	r4, r4, #2
	strh	r5, [r1]
	add	r1, r1, #2
	sub	r3, r3, #1
	cmp	r3, #0
	bne	LoadPixel
	add	r0, r0, r6
	sub	r2, r2, #1
	cmp	r2, #0
	bne	NewRow
	mov	r1, #$40
	mov	r2, #$ff
	mov	r3, #$7f
	mov	r1, r1, asl #20
	mov	r2, r2, asl #8
	orr	r2, r3, r2
	ldrh	r0, [r1]
	and	r0, r0, r2
	strh	r0, [r1] ; clear FB flag
	add	r1, r1, #4
	ldrh	r0, [r1]
	orr	r0, r0, #8
	strh	r0, [r1] ; set DISPSTAT Vbl flag
	mov	r2, #1
	mov	r3, #$fc
	mov	r2, r2, asl #8
	orr	r2, r3, r2
	add	r1, r2, r1
	ldrh	r0, [r1]
	orr	r0, r0, #1
	strh	r0, [r1] ; set IE Vbl flag
	add	r1, r1, #8
	ldrh	r0, [r1]
	orr	r0, r0, #1
	strh	r0, [r1] ; allow interrupts generally
	b	$

	org	$82ffffc
	dc.l	0